# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include masterless::puppet::package
class masterless::puppet::package (
  String[1] $pkgbasename = '',
) {

  $pkgdmgurl = $facts['os']['release']['major'] ? {
    '15'      => "https://downloads.puppetlabs.com/mac/puppet6/10.11/x86_64/${pkgbasename}.osx10.11.dmg", # El Capitan
    '16'      => "https://downloads.puppetlabs.com/mac/puppet6/10.12/x86_64/${pkgbasename}.osx10.12.dmg", # Sierra
    '17'      => "https://downloads.puppetlabs.com/mac/puppet6/10.13/x86_64/${pkgbasename}.osx10.13.dmg", # High Sierra
    '18'      => "https://downloads.puppetlabs.com/mac/puppet6/10.14/x86_64/${pkgbasename}.osx10.14.dmg", # Mojave
  }

  if $facts['os']['family'] != 'Darwin' {
    warning('The masterless::package class only supports macOS.')
  } elsif $facts['puppet_user'] != 'root' {
    warning('Can only manage puppet-agent pkgdmg when running as root, skipping...')
  } else {
    # TODO: Bug? Puppet skips this resource if dots in filename
    package { regsubst($pkgbasename, '\.', '_', 'G'):
      ensure   => installed,
      provider => pkgdmg,
      source   => $pkgdmgurl,
    }
  }

}
