# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include masterless::puppet::service
class masterless::puppet::service (
  Enum['present', 'absent'] $ensure = 'present',
  String[1] $user = $masterless::user,
  String[1] $home = $masterless::home,
  String[1] $plist = $masterless::plist
) {

  include masterless::puppet::config

  exec { 'reload_job':
    command     => "/bin/launchctl unload -w ${plist} && /bin/launchctl load -w ${plist}",
    subscribe   => File["${home}/.puppet-masterless/run.sh", $plist],
    refreshonly => true,
  }

  if $ensure == 'present' {
    exec { 'ensure_job_loaded':
      command => "/bin/launchctl load -w ${plist}",
      unless  => "/bin/launchctl list | /usr/bin/grep com.github.puppet-masterless-${user}",
    }
  } else {
    exec { 'ensure_job_unloaded':
      command => "/bin/launchctl load -w ${plist}",
      onlyif  => "/bin/launchctl list | /usr/bin/grep com.github.puppet-masterless-${user}",
    }
  }

}
